{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.IpoptInterface.Classes.IpoptSolver
       (
         IpoptSolver,
         IpoptSolverClass(..),
         ipoptSolver__0,
         ipoptSolver__1,
         ipoptSolver_creator,
         ipoptSolver_getReducedHessian,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Internal.CToolsInstances ( )
import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.IpoptInterface.Data
import Casadi.IpoptInterface.Enums
import Casadi.Core.Data

-- direct wrapper
foreign import ccall unsafe "casadi__IpoptSolver__CONSTRUCTOR__0" c_casadi__IpoptSolver__CONSTRUCTOR__0
  :: Ptr (Ptr StdString) -> Ptr Function' -> IO (Ptr IpoptSolver')
casadi__IpoptSolver__CONSTRUCTOR__0
  :: Function -> IO IpoptSolver
casadi__IpoptSolver__CONSTRUCTOR__0 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IpoptSolver__CONSTRUCTOR__0 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ipoptSolver__0 :: Function -> IO IpoptSolver
ipoptSolver__0 = casadi__IpoptSolver__CONSTRUCTOR__0


-- direct wrapper
foreign import ccall unsafe "casadi__IpoptSolver__CONSTRUCTOR__1" c_casadi__IpoptSolver__CONSTRUCTOR__1
  :: Ptr (Ptr StdString) -> IO (Ptr IpoptSolver')
casadi__IpoptSolver__CONSTRUCTOR__1
  :: IO IpoptSolver
casadi__IpoptSolver__CONSTRUCTOR__1  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IpoptSolver__CONSTRUCTOR__1 errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ipoptSolver__1 :: IO IpoptSolver
ipoptSolver__1 = casadi__IpoptSolver__CONSTRUCTOR__1


-- direct wrapper
foreign import ccall unsafe "casadi__IpoptSolver__creator" c_casadi__IpoptSolver__creator
  :: Ptr (Ptr StdString) -> Ptr Function' -> IO (Ptr NLPSolver')
casadi__IpoptSolver__creator
  :: Function -> IO NLPSolver
casadi__IpoptSolver__creator x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IpoptSolver__creator errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ipoptSolver_creator :: Function -> IO NLPSolver
ipoptSolver_creator = casadi__IpoptSolver__creator


-- direct wrapper
foreign import ccall unsafe "casadi__IpoptSolver__getReducedHessian" c_casadi__IpoptSolver__getReducedHessian
  :: Ptr (Ptr StdString) -> Ptr IpoptSolver' -> IO (Ptr DMatrix')
casadi__IpoptSolver__getReducedHessian
  :: IpoptSolver -> IO DMatrix
casadi__IpoptSolver__getReducedHessian x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IpoptSolver__getReducedHessian errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
ipoptSolver_getReducedHessian :: IpoptSolverClass a => a -> IO DMatrix
ipoptSolver_getReducedHessian x = casadi__IpoptSolver__getReducedHessian (castIpoptSolver x)

